#include "systemc.h"
#include "stati.h"


SC_MODULE(control_unit){
 sc_in<bool> clock;
 sc_in<bool> rst;
 sc_in<int> opcode;
 sc_out<bool> MemRead,MemWrite;
 
 sc_out<bool> AWrite;
 sc_out<bool> AluWrite;
 sc_out<bool> RegWrite;
 sc_out<int> state;
 
 sc_signal<stati> stato;

 void process_next_state();
 
 void process_genera_output();

 SC_CTOR(control_unit) {
   SC_METHOD(process_next_state);
   sensitive << clock.pos();
   sensitive << rst;
   SC_METHOD(process_genera_output);
   sensitive << stato;
  }
};
 





